
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>TQFS文件系统架构说明（又一个最适合Nandflash的轻量级嵌入式文件系统） / 憋错料</title>

    <meta name="description" content="TQFS文件系统架构说明（又一个最适合Nandflash的轻量级嵌入式文件系统） 前言  根据NandFlash的一些特性,读写速度快,生产工艺问题或多或少存在坏块,最小擦除单位为块,最小读取单位为字节,并且不能频繁对其进行擦写操作,最先对NandFlash支持最好的就是Yaffs文件系统,但Yaffs文件系统最大支持的页大小为512Byte,Yaffs2支持页大小可以达到2048Byte 但针对那些像linux的大型操作系统不管是Rom和Ram的开销确实不算什么,但如果只是把它应用在ram只有几十Kbyte的单片机上也是经过裁剪再裁剪才能放进去,这就需要诞生一种集Yaffs">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">TQFS文件系统架构说明（又一个最适合Nandflash的轻量级嵌入式文件系统）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong></strong></p>
<p>前言&nbsp; 根据NandFlash的一些特性，读写速度快，生产工艺问题或多或少存在坏块，最小擦除单位为块，最小读取单位为字节，并且不能频繁对其进行擦写操作，最先对NandFlash支持最好的就是Yaffs文件系统，但Yaffs文件系统最大支持的页大小为512Byte，Yaffs2支持页大小可以达到2048Byte 但针对那些像linux的大型操作系统不管是Rom和Ram的开销确实不算什么，但如果只是把它应用在ram只有几十Kbyte的单片机上也是经过裁剪再裁剪才能放进去，这就需要诞生一种集Yaffs优点<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA4MDUxNzQ4MzM1NzE/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZEhKMGIzTT0vZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9DZW50ZXI=.jpg">于一身，而且对硬件要求很低的文件系统，这是TQFS文件系统的初衷。</p>
<p>TQFS文件系统的优点</p>
<p><strong>需要的Rom少：</strong>大概一千五百多行代码</p>
<p><strong>需要的Ram少：</strong>平均需要建立的全局变量不大于基本都是用来存储一些使用Tab表的偏移位置及内容存储区的偏移位置等信息，其他局部变量的最大开销不会超过80Byte。</p>
<p><strong>文件系统稳定性好：</strong>就算文件系统局部出现灾难性的故障，依然可以读取文件系统中完整的个别文件，这点是在其他类型文件系统中不具备的。</p>
<p><strong>对硬件伤害小:</strong>在一块&#26684;式化完整的NandFlash上进行写入文件，在NandFlash没有写满的情况下，TQFS是不会对其进行擦出块操作。</p>
<p><strong>文件大小没有限制：</strong>文件最大可以在一个存储设备上存储一个文件，最小可以存储的文件个数，理论上是，一个存储设备上除去Tab占据的一个块外，剩余块上每页都可以存放一个文件，不足占据一页的算作一页，以K9f2g08为例最多可以存放文件为2048*64-64个文件，每个文件大小为2Kbyte。</p>
<p><strong>高效率性：</strong>存储一个文件不需要整块空间，当需要对很久以前的文件进行内容追加时，系统会寻找空白页写新的内容并且与之前的文件通过地址关联链接成一个文件，删除文件也可以只删除文件头，文件中间页可以在块回收的时候进行整理，</p>
<p><strong>文件类型多样性：</strong>可以存放的文件类型除了文件夹文件类型还增加了一些特殊类型，如链接类型和和根目录类型，可以在文件系统中建立多个根目录，相当于硬盘中的多个分区一样。</p>
<p>如下是每个存储页的首字节标志，用来标识该页的内容。利用NandFlash的擦除过程是从非1擦除到1的过程，为了避免再次擦除，文件类型确定了是不能进行修改，但该页属于整个文件的的组成部分位置可以从文件头，改为文件按中或文件尾，但一旦改为文件尾，该文件的大小就确定了，不能对其进行追加操作。</p>
<p>enumFileType{</p>
<p>FT_NotUsed=0xff,//页未被使用</p>
<p>FT_ReadyRoom=0x7f,//未定义长度的泛型文件存储区</p>
<p>FT_File=0x1f,//文件类型的未定义长度存储区</p>
<p>FT_FileHead=0x1e,//文件首</p>
<p>FT_FileCenter=0x1c,//文件中</p>
<p>FT_FileEnd=0x18,//文件尾部</p>
<p>FT_Folde=0x2f,//文件夹类型的未定义长度存储区</p>
<p>FT_FolderHead=0x2e,//文件夹头标志</p>
<p>FT_FolderCenter=0x2c,//文件夹中间标志</p>
<p>FT_FolderEnd=0x28,//文件夹尾标志</p>
<p>FT_Link=0x3f,//链接类型的未定义长度存储区</p>
<p>FT_LinkHead=0x3e,//链接文件头标志</p>
<p>FT_LinkCenter=0x3c,//链接文件中间标志</p>
<p>FT_LinkEnd=0x38,//链接文件尾标志</p>
<p>FT_RootDir=0x4f,//路径文件标志</p>
<p>FT_RootDirHead=0x4e,//根文件头标志</p>
<p>FT_RootDirCenter=0x4c,//根文件中间标志</p>
<p>FT_RootDirEnd=0x48,//根文件尾标志</p>
<p>FT_Delete=0x08,//文件被删除标志</p>
<p>FT_Tab=0x6f,//文件页被用来存放Tab表标志</p>
<p>FT_Bad=0x00&nbsp;&nbsp;&nbsp;&nbsp; //页损坏标志</p>
<p>};</p>
<p><strong>文件系统的可扩展性：</strong>该套文件系统架构是在k9f2g08上测试的，理论上可以兼容所有规模的NandFlash，且如果文件TAB表损坏或丢失，都可以花一些时间去搜索文件存储区来重构文件TAB表。</p>
<p><strong>文件的坏块管理：</strong>文件的坏块管理通过写页的标志位为0x00来却别该页是否是不可用页，这比传统的坏块管理好在，如果一个存储设备的某个块并不是全部算坏，而只是某个页上局部位置损坏，（NandFlash坏区的定义为，擦除不为全1的为损坏），那么该块的其他页照常可以使用。</p>
<p><strong>文件的擦除平衡：</strong>往文件系统里写入文件是从前往后找可用页一次向后写，当写到不能再写入内容的时候，系统会自动启用删除块回收，回收是也是从前往后的顺序找出所有可擦除块对其进行擦写，保证了系统不会频繁的对某个特定块进行反复擦写。从而实现了均衡擦除。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA4MDUxNzUzNDI5MzU/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZEhKMGIzTT0vZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9DZW50ZXI=.jpg"></p>
<p><strong>TQFS文件系统底层架构</strong>包含对NandFlash的整体规划使用区域划分，文件Tab位置的确定是在&#26684;式化NandFlash的过程中决定的，通常，Tab的位置被定在首个非坏块上，Tab占用一个存储块，文件其余块为文件内容存储区，文件内容存储区的位置都是使用的相对偏移位置，即认为紧跟Tab所在块后面一个非坏块的位置为基地址，Tab中每页的Data区域（存放数据内容的区域）的每个字节对应内容存储区的每页，且与内容存储区每页的Spare的首字节的内容是保持一致的，Tab实际上是为加快文件搜索和统计的速度而设定的。<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA4MDUxNzQ2MDg4ODA/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZEhKMGIzTT0vZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9DZW50ZXI=.jpg"></p>
<p><strong>泛型文件管理层</strong>该层定义了文件内容存储区的每页数据结构，每页的Spare区域左对齐存放File_Infor结构类型数据，描述该页的详细信息，每页的数据内容存储区域存放文件内容数据，该文件内容由File_Infor数据结构中的FileType决定，如果是普通文件类型，那么在该区域存放的是文件内容数据，这跟其他文件系统一样，如果是文件夹类型，那么该页存放的是链接，链接的长度通常是8字节对齐，每8字节描述一个链接文件，首字节存的是链接指向文件的文件类型，紧接着存放的是链接指向的文件地址，链接指向的类型也可以是全部类型，文件夹里存放的链接与链接文件里存放的链接基本是相同的，但是链接文件中的存放的链接地址指向的可以是文件的非头部分，但文件夹里的链接就只能指向文件的首部。<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA4MDUxNzQ4MTkxNzI/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZEhKMGIzTT0vZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9DZW50ZXI=.jpg"></p>
<p><P>TQFS文件系统架构说明（又一个最适合Nandflash的轻量级嵌入式文件系统）</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-03 03:56:36 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/trtos%e5%b5%8c%e5%85%a5%e5%bc%8f%e6%93%8d%e4%bd%9c%e7%b3%bb%e7%bb%9f/" title="trtos嵌入式操作系统">trtos嵌入式操作系统</a>, <a href="https://www.biecuoliao.com/tag/tqfs%e6%96%87%e4%bb%b6%e7%b3%bb%e7%bb%9f/" title="tqfs文件系统">tqfs文件系统</a>, <a href="https://www.biecuoliao.com/tag/%e5%b5%8c%e5%85%a5%e5%bc%8f%e6%96%87%e4%bb%b6%e6%93%8d%e4%bd%9c%e7%b3%bb%e7%bb%9f/" title="嵌入式文件操作系统">嵌入式文件操作系统</a>, <a href="https://www.biecuoliao.com/tag/%e9%80%82%e5%90%88nandflash%e7%9a%84%e6%96%87%e4%bb%b6%e7%b3%bb%e7%bb%9f/" title="适合nandflash的文件系统">适合nandflash的文件系统</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>TQFS文件系统架构说明（又一个最适合Nandflash的轻量级嵌入式文件系统）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xZdyk4.html" rel="bookmark">Ceph：一个开源的 Linux PB 级分布式文件系统</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				探索 Ceph 文件系统和生态系统 M. Tim Jones , 自由作家 简介:  Linux®持续不断进军可扩展计算空间,特别是可扩展存储空间.Ceph 最近才加入到 Linux 中令人印象深刻的文件系统备选行列,它是一个分布式文件系统,能够在维护 POSIX 兼容性的同时加入了复制和容错功能.探索 Ceph 的架构,学习它如何提供容错功能,简化海量数据管理. 标记本文! 发布日期:  2010 年 6 月 12 日 级别:  中级 其他语言版本:  英文 访问情况  5726 次浏览 建议			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wDV2l4.html" rel="bookmark">&lbrack;转载&rsqb; 【冬瓜哥手绘雄文】集群文件系统架构演变终极深度梳理图解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:  http://mp.weixin.qq.com/s?__biz=MzAwNzU3NzQ0MA==&amp;mid=209298809&amp;idx=1&amp;sn=70f93b7d71fa7ac9caf3c737fb20a2ad&amp;scene=1&amp;key=c76941211a49ab58a5fed01be2b1651eadbc89e3a9495b276185efdb2282d0fdd5b3aca4129a665495d1b65b77a9a848&amp;ascene=0&amp			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEZ6Qg0.html" rel="bookmark">分布式文件系统架构GFS、HDFS、TFS、Haystack</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				分布式文件系统架构GFS.HDFS.TFS.Haystack 分布式文件系统很多,包括GFS,HDFS,淘宝开源的TFS,Tencent用于相册存储的TFS (Tencent FS,为了便于区别,后续称为QFS),以及Facebook Haystack. 分布式文件系统通常可以作为底层存储,如GFS作为Google bigtable的底层,EBS作为 Amazon RDS的底 层,HDFS作为HBase的底层文件系统 其中,TFS,QFS以及Haystack需要解决的问题以及架构都很类似,这三个			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0ekDow4.html" rel="bookmark">Ext4文件系统架构分析&lpar;二&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				接着上一篇博文,继续分析Ext4磁盘布局中的元数据. 1.7 超级块 超级块记录整个文件系统的大量信息,如数据块个数.inode个数.支持的特性.管理信息,等待. 如果设置sparse_super特性标志,超级块和块组描述符表的冗余备份仅存放在编号为0或3.5.7的幂次方的块组中.如果未设置sparse_super特性标志,冗余备份存在与所有的块组中.以下是2.6.32.18内核中对Ext4超级块的描述: 3.0的内核中,Ext4的超级块加入了以下相关元数据:快照.文件系统错误处理相关.挂载选项			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YGweX4.html" rel="bookmark">一个特别适合新手练习的Android小项目&mdash;&mdash;每日一妹纸</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				介绍 每天更新一张精选妹纸图片,第一版目前已完成,本项目会持续更新,遇到任何问题欢迎与我联系^_^ 为什么说这是一个特别适合新手练习的小项目? 服务器API接口功能丰富且无访问次数限制 包含了常见的网络通信,数据缓存等功能 使用了流行的Realm,Retrofit,Glide,Butterknife等开源项目,方便新手学习他们的使用 遵循Material Design规则 示例 项目当然是开源的啦,源码请戳下面的链接 https://github.com/SparkYuan/Meizi ----			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmmYAVM.html" rel="bookmark">如何在cocos2d-x中使用ECS&lpar;实体-组件-系统&rpar;架构方法开发一个游戏？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引言 在我的博客中,我曾经翻译了几篇关于ECS的文章.这些文章都是来自于Game Development网站.如果你对这个架构方式还不是很了解的话,欢迎阅读理解 组件-实体-系统和实现 组件-实体-系统. 我发现这个架构方式,是在浏览GameDev上的文章的时候了解到的.很久以前,就知道了有这么个架构方法,只是一直没有机会自己实践下.这一次,我就抽空,根据网上对ECS系统的讨论,采用了一种实现方法,来实现一个. 我很喜欢做游戏,所以同样的,还是用游戏实例来实践这个架构方法.我将会采用cocos2			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4p6dAx0.html" rel="bookmark">FastDFs 开源的轻量级分布式文件系统部署</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.技术背景介绍; FastDFS是一个开源的轻量级分布式文件系统,它对文件进行管理,功能包括:文件存储.文件同步.文件访问(文件上传.文件下载)等,解决了大容量存储和负载均衡的问题.特别适合以文件为载体的在线服务,如相册网站.视频网站等等.FastDFS为互联网量身定制,充分考虑了冗余备份.负载均衡.线性扩容等机制,并注重高可用.高性能等指标,使用FastDFS很容易搭建一套高性能的文件服务器集群提供文件上传.下载等服务. 2.基础环境介绍; 主机名 IP地址规划 相关软件源码包汇总 服务器角			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXjWyq3.html" rel="bookmark">轻量级分布式文件系统FastDFS使用安装说明手册（新手入门级）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				轻量级分布式文件系统FastDFS使用安装说明手册(新手入门级) 实验室所在的课题组以研究云计算为主,但所有的研究都是在基于理论的凭空想像,缺少分布式环境的平台的实践,云计算神马的都是浮云了.因此,我想借助Hadoop把实验室的服务器搭建出一个基础的分布式实验环境,方便于以后进行实验测试神马的.无意中,看到了一款开源的轻量级分布式文件系统FastDFS,它是用纯C语言实现,详细信息可参见博客:分布式文件系统FastDFS架构剖析.通过收集资料,自己动手做了一些安装和测试使用,现在对前人的一些经验			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YvXnr3.html" rel="bookmark">FastDFS轻量级分布式文件系统部署</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				FastDFS介绍 FastDFS 是一个由 C 语言实现的开源轻量级分布式文件系统,作者余庆,支持 Linux.FreeBSD.AID 等 Unix 系统,解决了大数据存储和读写负载均衡等问题,适合存储 4KB~500MB 之间的小文件,如图片网站.短视频网站.文档.app 下载站等,UC.京东.支付宝.迅雷.酷狗等都有使用. FastDFS上传下载的流程 4.4 利用Java客户端调用FastDFS 服务器安装完毕后,咱们通过Java调用fastdfs 加载Maven依赖 fastdfs 没			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n4Aeav4.html" rel="bookmark" class="title">人工智能预测精神病</a>
					<div>
						认知,精神疾病和人工智能算法研究 精神疾病从严格意义上讲是由于大脑功能失常引起的疾病.引起大脑功能失常的原因有很多,如基因突变.缺失或重叠.大脑外伤等,都可引起多方面的大脑功能紊乱,导致患者在感知.思 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVgqa10.html" rel="bookmark" class="title">&lbrack;JavaWeb基础&rsqb; 017&period;Struts2 和 ajax交互简介</a>
					<div>
						在网页开发中,我们为了只对网页的某块内容进行实时更新,而不对其他不需要更新的内容进行刷新,从而提高响应速度和节省流量,我们采用了页面的异步刷新技术Ajax,那么我们的Struts2框架在这一方面是如何 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YgKdO4.html" rel="bookmark" class="title">Protocol Buffer技术详解&lpar;语言规范&rpar;</a>
					<div>
						Protocol Buffer技术详解(语言规范) 该系列Blog的内容主体主要源自于Protocol Buffer的官方文档,而代码示例则抽取于当前正在开发的一个公司内部项目的Demo.这样做的目的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mzav8O4.html" rel="bookmark" class="title">java反射机制剖析（三）&mdash;类类型Class</a>
					<div>
						为了区别于我们常用的Class,因此给了个中文名类类型.目的就是为了知道此Class非彼Class.上一篇博客已经介绍了Class Loader,它的作用是根据提供的信息来加载类到内存中.我之前有提过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xQPXQ3.html" rel="bookmark" class="title">shiroWeb项目-登陆与退出实现&lpar;九&rpar;</a>
					<div>
						原理 使用FormAuthenticationFilter过虑器实现 ,原理如下: 将用户没有认证时,请求loginurl进行认证,用户身份和用户密码提交数据到loginurl FormAuthent ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/My5NzpM.html" rel="bookmark" class="title">js中动态加载---append</a>
					<div>
						$('#Order_information').append('&lt;div class=&quot;single_product&quot;&gt; &lt;div class=&quot;Can ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AdrKa3.html" rel="bookmark" class="title">Dispatcher Queue性能分析</a>
					<div>
						一直想要写一点东西,把自己在工作中遇到的东西分享给大家,无奈水平有限,每每想写的时候,就感觉写的东西太过浮浅,同样的东西不如其它人写的有水平,假若自己再写出来可能会给其它人带来困惑,加上自己语言组织能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qQorz3.html" rel="bookmark" class="title">WPF换肤之八：创建3D浏览效果</a>
					<div>
						原文:WPF换肤之八:创建3D浏览效果 上节中,我们展示了WPF中的异步以及界面线程交互的方式,使得应用程序的显示更加的流畅.这节我们主要讲解如何设计一个具有3D浏览效果的天气信息浏览器. 效果显示  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pz8rJ0.html" rel="bookmark" class="title">js事件相关知识点总结</a>
					<div>
						HTML页面是怎样实现交互的? 2017-05-22 js事件之事件流: 事件流原理图:事件流是从window开始,最后回到window的一个过程,分为三个阶段(1~5)捕获过程.(5~6)目标过程. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YRR7N3.html" rel="bookmark" class="title">Javascript 编程小技巧总结（部分内容借鉴他人）</a>
					<div>
						1 – 使用===,而不是＝＝ ==(或!=)操作符在需要的时候会自动执行类型转换.===(或!==)操作不会执行任何转换.它将比较值和类型,而且在速度上也被认为优于==. 2 – 使用闭包实现私有变 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YRQey3.html" rel="bookmark" class="title">EasyUI1-easyui介绍</a>
					<div>
											</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YRzYN3.html" rel="bookmark" class="title">存储过程中用游标联动插入（商品分类）</a>
					<div>
						例子:往商品表插入的同时,也将对应的多个分类加入到商品分类表中 create PROCEDURE TProduct_ADD@ProID bigint output, --自动编号@ISBN nvarc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MglKPO0.html" rel="bookmark" class="title">沫沫金：Java快速合并两个数组【绝技】</a>
					<div>
						需求: 合并两个Object[] a 和Object[] b: 方案 List&lt;Object[]&gt; quotas = new ArrayList&lt;Object[]&gt;(); Ob ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/471Xdk0.html" rel="bookmark" class="title">Spring AOP 的实现 原理</a>
					<div>
						反射实现 AOP 动态代理模式实例说明(Spring AOP 的实现 原理) 比如说,我们现在要开发的一个应用里面有很多的业务方法,但是,我们现在要对这个方法的执行做全面监控,或部分监控.也许我们就会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pLwx84.html" rel="bookmark" class="title">Linux Virtual Server技术</a>
					<div>
						1 LVS简单介绍 Linux VirtualServer是一个高扩展和高可用性server,在一个真正server的集群中构建而成,包括Linux操作系统中的负载均衡. server的架构对于终端用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e9AJE0.html" rel="bookmark" class="title">怎样用java编程抓取动态生成的网页</a>
					<div>
						最近在做项目的时候有一个需求:从网页面抓取数据,要求是首先抓取整个网页的html源码(后期更新要使用到).刚开始一看这个简单,然后就稀里哗啦的敲起了代码(在这之前使用过Hadoop平台的分布式爬虫框架 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41GB7g0.html" rel="bookmark" class="title">VMware vSphere（监控vSphere性能）&lpar;十三&rpar;</a>
					<div>
						如何快速的查看某台主机的使用请情况 最快捷的方法如下图 下面是监视某台主机的 告警可以通过预先定义的触发器而产生 从而产生一个行为 比如说邮件 运行一个脚本 告警也分为层次的 告警创建的位子的不同 调 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wpbj14.html" rel="bookmark" class="title">dbms&lowbar;job涉及到的知识点</a>
					<div>
						用于安排和管理作业队列,通过使用作业,可以使ORACLE数据库定期执行特定的任务. 一.dbms_job涉及到的知识点1.创建job:variable jobno number;dbms_job.su ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OQYZGM.html" rel="bookmark" class="title">mysql 修改root登录密码</a>
					<div>
						mysql -u root -p 然后回车,进入(等于用空密码进入) 2 use mysql; update user set password=password('123456') where us ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vDALZM.html" rel="bookmark" class="title">程序员写的东西出了bug&comma;造成了损失谁来承担？</a>
					<div>
						这是个持续多年的话题了,很多大公司,尤其是牛逼的独立分包公司(开发公司)都会有代码审核和严格QA程序,一般的公司就很难说咯,在法律上目前还没有完全支持处罚程序员bug经济损失的判例(国内如此),国外也 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.025 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
